<?php
/*
 * @component XLSJuice
 * @copyright Copyright (C) February 2019.
 * @license GPL 3.0
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * See <http://www.gnu.org/licenses/>.
 * More info www.moonsoft.es
 * gestion@moonsoft.es
 */
// No direct access to this file
defined ( '_JEXEC' ) or die ( 'Restricted access' );

use Joomla\CMS\Version;
use Joomla\CMS\Factory;
use Joomla\CMS\Uri\Uri;

class com_xlsjuiceInstallerScript {
	/**
	 * method to install the component
	 *
	 * @return void
	 */
	function install($parent) {
		// echo 'Install';
	}

	/**
	 * method to uninstall the component
	 *
	 * @return void
	 */
	function uninstall($parent) {
		// $parent is the class calling this method
		echo '<p>Thanks for using XLSJuice</p>
    <p><hr/>If you have any question, problem or comment, please send us an email: <a href="mailto:contact@xlsjuice.com">contact@xlsjuice.com</a> or visit our web page <a href="http://www.xlsjuice.com" target="_blank">www.xlsjuice.com</a><br/>
    </p>';
	}

	/**
	 * method to update the component
	 *
	 * @return void
	 */
	function update($parent) {
		// $parent is the class calling this method
		// echo '<h3>Updated</h3>';
	}

	/**
	 * method to run before an install/update/uninstall method
	 *
	 * @return void
	 */
	function preflight($type, $parent) {
		 if ($type != 'uninstall') {
            $jversion = new Version();

            // Installing component manifest file version
            //$this->release = $parent->get( "manifest" )->version;
            $this->release = $parent->getManifest()->version;

            // Manifest file minimum Joomla version
            $this->minimum_joomla_release = $parent->getManifest()->attributes()->version;

            // abort if the current Joomla release is older
            if (version_compare($jversion->getShortVersion(), $this->minimum_joomla_release, 'lt')) {
                Jerror::raiseWarning(null, 'Cannot install this version of XLSJuice in a Joomla release prior to ' . $this->minimum_joomla_release);
                return false;
            } else {
                $rel = $this->release;
            }
            $base = Uri::root();
            echo <<<EOD
<div class="container-fluid">                                    
    <div class="row">          
        <div class="col-12 col-sm-8">            
            <h1 class="display-5 mx-auto"><img class="mr-3" src="{$base}administrator/components/com_xlsjuice/assets/img/xlsjuice.svg" alt="XLSJuice" style="width: 250px;"></h1>
            <h3>Installation info</h3>                                      
            <dl class="row">
                <dt class="col-sm-6">Installing component version</dt>
                <dd class="col-sm-6 font-monospace">{$this->release}</dd>           
                <dt class="col-sm-6">Installing minimum Joomla version</dt>
                <dd class="col-sm-6 font-monospace">{$this->minimum_joomla_release}</dd>
                <dt class="col-sm-6">Current Joomla version</dt>
                <dd class="col-sm-6 font-monospace">{$jversion->getShortVersion()}</dd>
            </dl>
        </div>
        <div class="col-12 col-sm-4">
            <div class="card">
              <img src="{$base}administrator/components/com_xlsjuice/assets/img/logo_b.png" class="card-img-top p-4" alt="Moonsoft">
              <div class="card-body">
                <p class="card-text text-center">
                    <a href="http://www.moonsoft.es">Moonsoft Software Solutions</a>
                </p>
              </div>
            </div>       
        </div>       
    </div>       
</div>       
EOD;
        }
	}

	/**
	 * method to run after an install/update/uninstall method
	 *
	 * @return void
	 */
	function postflight($type, $parent) {}

	function getParam($name) {
	
  	$db = Factory::getDbo();
        $db->setQuery('SELECT manifest_cache FROM #__extensions WHERE element = "com_xlsjuice" and type="component"');
        $manifest = json_decode($db->loadResult(), true);
        return ($name!=null&&$manifest!=null)?$manifest[$name]:'';
	}

}

?>
